// 003 u_cgi_strings_html
// 19 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

// -- special because it does not use u_display

(*$r+*)
unit u_cgi_strings_html;
  interface
    uses Classes;

    function f_is_file_name(p_file_name: String): Boolean;
    function f_is_zip_or_ppt_name(p_file_name: String): Boolean;

    function f_is_html_name(p_file_name: String): Boolean;
    function f_is_zip_name(p_file_name: String): Boolean;
    function f_is_pdf_name(p_file_name: String): Boolean;
    function f_is_ppt_name(p_file_name: String): Boolean;
    function f_is_exe_name(p_file_name: String): Boolean;
    function f_is_jpeg_name(p_file_name: String): Boolean;

    function f_is_top_name(p_file_name: String): Boolean;
    function f_is_frame_name(p_file_name: String): Boolean;
    function f_is_frame_or_top_name(p_file_name: String): Boolean;
    function f_name_without_frame_or_top(p_file_name: String): String;
    function f_is_sample_name(p_file_name: String): Boolean;
    function f_is_404_name(p_file_name: String): Boolean;

    function f_normalize_url(p_url: String): String;
    function f_compact_url(p_url: String): String;

    // function f_nbsp(p_count: Integer): String;

    // function f_remove_end_if_end_is_equal_to(p_string, p_end: String): String;

  implementation
    uses SysUtils
        // , u_display
        , u_cgi_strings
        ;

(*
    function f_remove_end_if_end_is_equal_to(p_string, p_end: String): String;
      begin
        if f_end_is_equal_to(p_string, p_end)
          then Result:= Copy(p_string, 1, Length(p_string)- Length(p_end))
          else Result:= p_string;
      end; // f_remove_end_if_end_is_equal_to
*)
    function f_is_file_name(p_file_name: String): Boolean;
      begin
        Result:= Pos('.', p_file_name)> 0
      end; // f_is_file_name

    function f_is_html_name(p_file_name: String): Boolean;
      var l_extension: String;
      begin
        l_extension:= ExtractFileExt(p_file_name);
        Result:= UpperCase(l_extension)= '.HTML';
      end; // f_is_html_name

    function f_is_zip_name(p_file_name: String): Boolean;
      begin
        Result:= f_end_is_equal_to(UpperCase(p_file_name), '.ZIP');
      end; // f_is_zip_name

    function f_is_pdf_name(p_file_name: String): Boolean;
      begin
        Result:= f_end_is_equal_to(UpperCase(p_file_name), '.PDF');
      end; // f_is_pdf_name

    function f_is_ppt_name(p_file_name: String): Boolean;
      begin
        Result:= f_end_is_equal_to(UpperCase(p_file_name), '.PPT');
      end; // f_is_ppt_name

    function f_is_exe_name(p_file_name: String): Boolean;
      begin
        Result:= f_end_is_equal_to(UpperCase(p_file_name), '.EXE');
      end; // f_is_exe_name

    function f_is_jpeg_name(p_file_name: String): Boolean;
      begin
        Result:= f_end_is_equal_to(UpperCase(p_file_name), '.JPEG');
      end; // f_is_exe_name

    function f_is_zip_or_ppt_name(p_file_name: String): Boolean;
      var l_extension: String;
      begin
        l_extension:= UpperCase(ExtractFileExt(p_file_name));
        Result:= (l_extension= '.ZIP') or (l_extension= '.PPT');
      end; // f_is_zip_or_ppt_name

    function f_is_top_name(p_file_name: String): Boolean;
      var l_length: Integer;
      begin
        if UpperCase(ExtractFileExt(p_file_name))= '.HTML'
          then begin
              l_length:= Length(p_file_name);
              Result:= (l_length> 4+ 5) and (UpperCase(Copy(p_file_name, l_length- 4- 5+ 1, 4))= '_TOP')
           end
         else Result:= False;
      end; // f_is_top_name

    function f_is_frame_name(p_file_name: String): Boolean;
      var l_length: Integer;
      begin
        if UpperCase(ExtractFileExt(p_file_name))= '.HTML'
          then begin
              l_length:= Length(p_file_name);
              Result:= (l_length> 6+ 5) and (UpperCase(Copy(p_file_name, l_length- 6- 5+ 1, 6))= '_FRAME');
           end
         else Result:= False;
      end; // f_is_frame_name

    function f_is_frame_or_top_name(p_file_name: String): Boolean;
      begin
        Result:= f_is_frame_name(p_file_name) or f_is_top_name(p_file_name);
      end; // f_is_frame_or_top_name

    function f_name_without_frame_or_top(p_file_name: String): String;
      var l_length: Integer;
      begin
        Result:= p_file_name;

        if UpperCase(ExtractFileExt(p_file_name))= '.HTML'
          then begin
              l_length:= Length(p_file_name);
              if (l_length> 6+ 5) and (UpperCase(Copy(p_file_name, l_length- 6- 5+ 1, 6))= '_FRAME')
                then Delete(Result, l_length- 6- 5+ 1, 6)
                else
                  if (l_length> 4+ 5) and (UpperCase(Copy(p_file_name, l_length- 4- 5+ 1, 4))= '_TOP')
                    then Delete(Result, l_length- 4- 5+ 1, 4);
           end;
      end; // f_name_without_frame_or_top

    function f_is_sample_name(p_file_name: String): Boolean;
        // -- get rid of "menu1.html"
      var l_file_name: String;
      begin
        // -- ++ check livre_n stage_n
        // -- other with number
        // --   index_
        // --   edito

        if f_is_html_name(p_file_name)
          then begin
              l_file_name:= f_name_without_frame_or_top(p_file_name);
              l_file_name:= f_without_end(l_file_name, '.html');
              Result:= l_file_name[Length(l_file_name)] in ['0', '1', '2', '3', '4'];
            end
          else Result:= False;
      end; // f_is_sample_name

    function f_is_404_name(p_file_name: String): Boolean;
      begin
        Result:= Pos('404', p_file_name)> 0;
      end; // f_is_404_name

    function f_normalize_url(p_url: String): String;
        // -- "12.1.456.18" -> "_12.__1.456._18"
      var l_index: Integer;
          // l_segment_index, l_result_index, l_fill
          l_segment: String;
      begin
        Result:= '';

        l_segment:= '';

        for l_index:= 1 to Length(p_url) do
        begin
          if p_url[l_index]= '.'
            then begin
                l_segment:= f_spaces(3- Length(l_segment))+ l_segment;
                Result:= Result+ l_segment+ '.';
                l_segment:= '';
              end
            else l_segment:= l_segment+ p_url[l_index];
        end; // for

        // -- last part
        l_segment:= f_spaces(3- Length(l_segment))+ l_segment;
        Result:= Result+ l_segment;
      end; // f_normalize_url

    function f_compact_url(p_url: String): String;
      var l_index: Integer;
      begin
        Result:= '';
        for l_index:= 1 to Length(p_url) do
          if p_url[l_index]<> ' '
            then Result:= Result+ p_url[l_index];
      end; // f_compact_url

(*
    function f_nbsp(p_count: Integer): String;
      var l_count: Integer;
      begin
        Result:= '';
        for l_count:= 0 to p_count- 1 do
          Result:= Result+ '&nbsp;';
      end; // f_nbsp
*)
    begin
    end.

